=== debian/changelog ===
notcurses (2.1.7+dfsg.1-2) unstable; urgency=medium

  * Source-only upload to initiate transition to testing.

 -- Nick Black <dankamongmen@gmail.com>  Mon, 01 Feb 2021 01:22:42 -0500

notcurses (2.1.7+dfsg.1-1) unstable; urgency=medium

  * New upstream version.
  * libnotcurses-core has been split out of libnotcurses. The latter now
    only supplies multimedia support (using ffmpeg on Debian), with the
    remaining library functionality provided by libnotcurses-core. A
    binary linked against only libnotcurses-core.so requires no installed
    ffmpeg support, and thus a svelter dependency stack. The libnotcurses2
    package has thus been split into libnotcurses-core2 and libnotcurses2;
    libnotcurses-dev is now libnotcurses-core-dev and libnotcurses-dev.
  * "notcurses-view" has been renamed "ncplayer".

 -- Nick Black <dankamongmen@gmail.com>  Thu, 21 Jan 2021 03:23:34 -0500
