=== debian/changelog ===
notcurses (2.1.8+dfsg.1-1) unstable; urgency=medium

  * New upstream version
  * Update copyrights for ncart.c, extracted from neofetch

 -- Nick Black <dankamongmen@gmail.com>  Wed, 03 Feb 2021 08:39:12 -0500
