=== debian/control ===
--- 
+++ 
@@ -58,17 +58,15 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libnotcurses2 (= ${binary:Version}),
+Depends: libnotcurses-core2 (= ${binary:Version}),
          ${misc:Depends}
 Recommends: libnotcurses-dev
-Replaces: libnotcurses-dev (<< 2.1.6)
-Breaks: libnotcurses-dev (<< 2.1.6)
+Replaces: libnotcurses-dev (<< 2.1.7)
+Breaks: libnotcurses-dev (<< 2.1.7)
 Description: Character graphics and TUI library (development)
  Notcurses facilitates the creation of modern TUI programs, making
- full use of Unicode and 24-bit TrueColor. Its API is similar
- to that of NCURSES, but extends that with z-buffering, rendering
- of images and video using ffmpeg, alpha blending, widgets, palette
- fades, resize awareness, and multithreading support.
+ full use of Unicode and 24-bit TrueColor. This development
+ package covers the Notcurses core library.
  .
  These files are necessary for C development using Notcurses. They
  do not include multimedia support; that requires libnotcurses-dev.
@@ -98,15 +96,12 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Replaces: libnotcurses1 (>= 2),
-          libnotcurses2 (<< 2.1.6)
+          libnotcurses2 (<< 2.1.7)
 Breaks: libnotcurses1 (>= 2),
-        libnotcurses2 (<< 2.1.6)
+        libnotcurses2 (<< 2.1.7)
 Description: Character graphics and TUI library
  Notcurses facilitates the creation of modern TUI programs, making
- full use of Unicode and 24-bit TrueColor. Its API is similar
- to that of NCURSES, but extends that with z-buffering, rendering
- of images and video using ffmpeg, alpha blending, widgets, palette
- fades, resize awareness, and multithreading support.
+ full use of Unicode and 24-bit TrueColor.
  .
  This core library lacks multimedia support. For that,
  libnotcurses2 must be installed.
@@ -131,11 +126,11 @@
 Architecture: any
 Multi-Arch: foreign
 Section: graphics
-Depends: desktop-base,
-         notcurses-data (= ${source:Version}),
+Depends: notcurses-data (= ${source:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
-Recommends: ncurses-term,
+Recommends: desktop-base,
+            ncurses-term,
             python3-notcurses (>= ${source:Version})
 Description: Character graphics and TUI library demos
  Notcurses facilitates the creation of modern TUI programs,
