=== debian/changelog ===
notcurses (2.2.1+dfsg.1-1) unstable; urgency=medium

  * New upstream version, fixes brown-bag failure to discover
    UTF8 properly in Direct Mode.

 -- Nick Black <dankamongmen@gmail.com>  Tue, 09 Feb 2021 19:37:35 -0500

notcurses (2.2.0+dfsg.1-1) unstable; urgency=medium

  * New upstream version

 -- Nick Black <dankamongmen@gmail.com>  Mon, 08 Feb 2021 09:37:54 -0500
