## notcurses 2.2.2+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.2.1
+project(notcurses VERSION 2.2.2
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)
@@ -46,8 +46,8 @@
   set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE
     STRING "Choose the build mode." FORCE)
 endif()
-string(APPEND CMAKE_C_FLAGS_DEBUG " -O0")
-string(APPEND CMAKE_CXX_FLAGS_DEBUG " -O0")
+string(APPEND CMAKE_C_FLAGS_DEBUG " -Og")
+string(APPEND CMAKE_CXX_FLAGS_DEBUG " -Og")
 if("${USE_COVERAGE}")
   if(NOT "${CMAKE_C_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang")
     message(FATAL_ERROR "USE_COVERAGE was on but CC isn't clang")
