=== debian/changelog ===
notcurses (2.2.2+dfsg.1-1) unstable; urgency=medium

  * New upstream version. Fixes attribute reset on initial read
    in emulators lacking "oc" capability, and cursor placement on
    exit from direct mode.

 -- Nick Black <dankamongmen@gmail.com>  Thu, 18 Feb 2021 07:12:31 -0500
