## notcurses 2.2.3+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.2.2
+project(notcurses VERSION 2.2.3
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)
@@ -145,6 +145,7 @@
   PRIVATE
     include
     src
+    "${CMAKE_REQUIRED_INCLUDES}"
     "${PROJECT_BINARY_DIR}/include"
     "${TERMINFO_INCLUDE_DIRS}"
     "${READLINE_INCLUDE_DIRS}"
@@ -153,6 +154,7 @@
   PRIVATE
     include
     src
+    "${CMAKE_REQUIRED_INCLUDES}"
     "${PROJECT_BINARY_DIR}/include"
     "${TERMINFO_STATIC_INCLUDE_DIRS}"
     "${READLINE_STATIC_INCLUDE_DIRS}"
@@ -227,6 +229,7 @@
     include
     src
     src/lib
+    "${CMAKE_REQUIRED_INCLUDES}"
     "${PROJECT_BINARY_DIR}/include"
 )
 target_include_directories(notcurses-static
@@ -234,6 +237,7 @@
     include
     src
     src/lib
+    "${CMAKE_REQUIRED_INCLUDES}"
     "${PROJECT_BINARY_DIR}/include"
 )
 target_link_libraries(notcurses
@@ -384,7 +388,3 @@
     ${NCPP_COMPILE_DEFINITIONS_PUBLIC}
   )
 
-file(GLOB NOTCURSES_HEADERS
-  CONFIGURE_DEPENDS
-  LIST_DIRECTORIES false
-  ${PROJECT_SOURCE_DIR}/include/notcurses/*.h
