=== debian/changelog ===
notcurses (2.2.3+dfsg.1-1) unstable; urgency=medium

  * New upstream version, introducing nctree and NCBLIT_PIXEL.

 -- Nick Black <dankamongmen@gmail.com>  Mon, 08 Mar 2021 07:13:10 -0500
