=== debian/tests/control ===
# The CI pipeline on salsa.debian.org doesn't appear to export a TERM variable
# to the autopkgtest environment. We thus manually use TERM=xterm for all
# commands. They'd otherwise fail out, or (worse) not actually test anything.

# These two tests are currently marked flaky due to poorly-understood problems
# involving output of emoji when run in the autopkgtest suite FIXME.

# Basic unit test suite, but run with installed binary
Test-Command: TERM=xterm notcurses-tester
Depends: notcurses-bin
Restrictions: allow-stderr, flaky
Features: test-name=unittests

# Execute notcurses-demo with:
#  -c: seed PRNG with known constant for semi-reproducible timings
#  -m2: use 2-cell margins on all sides (to test margins)
#  -d0: delay multiplier of 0 (no artificial delays)
Test-Command: TERM=xterm notcurses-demo -c -m2 -d0
Depends: notcurses-bin
Restrictions: allow-stderr, flaky
Features: test-name=demo

# Execute notcurses-pydemo
Test-Command: TERM=xterm notcurses-pydemo
Depends: python3-notcurses
Restrictions: allow-stderr
Features: test-name=pydemo
