=== debian/watch ===
version=4

opts="pgpsigurlmangle=s/archive\/(v\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc/,\
      dversionmangle=s/\+dfsg(\.?\d+)?$//,\
      repacksuffix=+dfsg.1, \
      filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%notcurses-$1.tar.gz%" \
   https://github.com/dankamongmen/notcurses/releases (?:.*?/)?v?(\d[\d.]*)\.tar\.gz \
   debian uupdate
